/***************************************************************************
 *   Copyright (C) 2009 by Peter Semiletov                                 *
 *   peter.semiletov@gmail.com                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef UTILS_H
#define UTILS_H

#include <QtGui>


QString hash_keyval_to_string (const QHash<QString, QString> &h);
QHash<QString, QString> hash_load_keyval (const QString &fname);
QHash<QString, QString> stringlist_to_hash (const QStringList &l);

bool qstring_save (const QString &fileName, const QString &data);
QString qstring_load (const QString &fileName, const QString &charset = "UTF-8");
void qstring_list_print (const QStringList &l);

QString file_get_ext (const QString &file_name);
bool file_exists (const QString &fileName);

void create_menu_from_list (QObject *handler,
                            QMenu *menu,
                            const QStringList &list,
                            const char *method
                           );

bool is_image (const QString &filename);
bool is_text (const QString &filename);

void create_menu_from_dir (QObject *handler,
                           QMenu *menu,
                           const QString &dir,
                           const char *method
                           );


inline bool is_dir (const QString &path)
{
  return QFileInfo(path).isDir();
}

inline QString get_file_path (const QString &fileName)
{
  return QFileInfo (fileName).absolutePath();
}

inline int get_value (int total, int perc)
{
  return static_cast <int> ((total / 100) * perc);
}


#endif
